
Ruby - Bug #12405

Queue doesn't work inside of trap

05/20/2016 06:13 AM - kirillrdy (Kirill Radzikhovskyy)

Status: Closed   

Priority: Normal   

Assignee: ko1 (Koichi Sasada)   

Target version:    

ruby -v: ruby 2.3.1p112 (2016-04-26 revision

54768) [x86_64-linux]

Backport: 2.1: UNKNOWN, 2.2: DONE, 2.3:

DONE, 2.4: DONE

Description

when adding things to the queue inside that trap blocking pop never unblocks

q = Queue.new

Signal.trap 'INT' do

  puts "got INT"

  q << 'something'

end

Thread.new {

  loop {

    sleep 1

    Process.kill :INT, $$

  }

}

q.pop

 I know that there are limitations of what can be done inside of trap.

Looking at this https://bugs.ruby-lang.org/issues/6128 it looks like I should be able to use Queue inside a trap, but code above runs

forever.

Also in jruby it behaives as expected ( at least in my understanding )

Associated revisions

Revision bfdfc99cc2ea49f15b1380516bd341f4e7b425b6 - 01/31/2017 07:00 AM - ko1 (Koichi Sasada)

allow Queue operation in trap.

thread_sync.c: allow spurious wakeup to check Queue status just after trap.

[Bug #12405]

test/thread/test_queue.rb: add a test for it.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@57479 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision bfdfc99c - 01/31/2017 07:00 AM - ko1 (Koichi Sasada)

allow Queue operation in trap.

thread_sync.c: allow spurious wakeup to check Queue status just after trap.

[Bug #12405]

test/thread/test_queue.rb: add a test for it.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@57479 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 0c72a8f091eff82b71e045fc8049406d0a48ee85 - 03/11/2017 06:45 PM - naruse (Yui NARUSE)

merge revision(s) 57477,57478,57479: [Backport #12405]

    use TRUE/FALSE.

    define rb_thread_sleep_deadly_allow_spurious_wakeup().
    * thread.c, thread_sync.c: define new function

      rb_thread_sleep_deadly_allow_spurious_wakeup() and use it instead of

      using sleep_forever() directly.

    allow Queue operation in trap.

    * thread_sync.c: allow spurious wakeup to check Queue status just after trap.

      [Bug #12405]

    * test/thread/test_queue.rb: add a test for it.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_4@57879 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 0c72a8f0 - 03/11/2017 06:45 PM - naruse (Yui NARUSE)

merge revision(s) 57477,57478,57479: [Backport #12405]

    use TRUE/FALSE.

    define rb_thread_sleep_deadly_allow_spurious_wakeup().

    * thread.c, thread_sync.c: define new function

      rb_thread_sleep_deadly_allow_spurious_wakeup() and use it instead of

      using sleep_forever() directly.

    allow Queue operation in trap.

    * thread_sync.c: allow spurious wakeup to check Queue status just after trap.

      [Bug #12405]

    * test/thread/test_queue.rb: add a test for it.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_4@57879 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision e120cc91f0fedc876e23259ecdb9fb65c71e57dd - 03/20/2017 12:26 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 57477,57478,57479: [Backport #12405]

    use TRUE/FALSE.

    define rb_thread_sleep_deadly_allow_spurious_wakeup().

    * thread.c, thread_sync.c: define new function

      rb_thread_sleep_deadly_allow_spurious_wakeup() and use it instead of

      using sleep_forever() directly.

    allow Queue operation in trap.

    * thread_sync.c: allow spurious wakeup to check Queue status just after trap.

      [Bug #12405]

    * test/thread/test_queue.rb: add a test for it.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@58036 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision e120cc91 - 03/20/2017 12:26 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 57477,57478,57479: [Backport #12405]

    use TRUE/FALSE.

    define rb_thread_sleep_deadly_allow_spurious_wakeup().

    * thread.c, thread_sync.c: define new function

      rb_thread_sleep_deadly_allow_spurious_wakeup() and use it instead of

      using sleep_forever() directly.

    allow Queue operation in trap.

    * thread_sync.c: allow spurious wakeup to check Queue status just after trap.

      [Bug #12405]

    * test/thread/test_queue.rb: add a test for it.
 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@58036 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision d014f463cf6d5dd51aa2ce56385fc08ac5c121af - 03/25/2017 06:07 PM - U.Nakamura 

merge revision(s) 57477,57478,57479,57492: [Backport #12405]

    use TRUE/FALSE.

    define rb_thread_sleep_deadly_allow_spurious_wakeup().

    * thread.c, thread_sync.c: define new function

      rb_thread_sleep_deadly_allow_spurious_wakeup() and use it instead of

      using sleep_forever() directly.

    allow Queue operation in trap.

    * thread_sync.c: allow spurious wakeup to check Queue status just after trap.

      [Bug #12405]

    * test/thread/test_queue.rb: add a test for it.

    test_queue.rb: fix portability

    * test/thread/test_queue.rb (test_queue_with_trap): fix

      portability.  use SIGINT instead of SIGUSR2 which is supported

      on not all platforms.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_2@58115 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision d014f463 - 03/25/2017 06:07 PM - U.Nakamura 

merge revision(s) 57477,57478,57479,57492: [Backport #12405]

    use TRUE/FALSE.

    define rb_thread_sleep_deadly_allow_spurious_wakeup().

    * thread.c, thread_sync.c: define new function

      rb_thread_sleep_deadly_allow_spurious_wakeup() and use it instead of

      using sleep_forever() directly.

    allow Queue operation in trap.

    * thread_sync.c: allow spurious wakeup to check Queue status just after trap.

      [Bug #12405]

    * test/thread/test_queue.rb: add a test for it.

    test_queue.rb: fix portability

    * test/thread/test_queue.rb (test_queue_with_trap): fix

      portability.  use SIGINT instead of SIGUSR2 which is supported

      on not all platforms.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_2@58115 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 715f997ab706df797dd253d9ee706b1326365eae - 03/27/2017 03:49 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 57492: [Backport #12405]

    test_queue.rb: fix portability

    * test/thread/test_queue.rb (test_queue_with_trap): fix

      portability.  use SIGINT instead of SIGUSR2 which is supported

      on not all platforms.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@58164 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 715f997a - 03/27/2017 03:49 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 57492: [Backport #12405]

    test_queue.rb: fix portability

    * test/thread/test_queue.rb (test_queue_with_trap): fix
      portability.  use SIGINT instead of SIGUSR2 which is supported

      on not all platforms.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@58164 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 05/27/2016 09:15 AM - ko1 (Koichi Sasada)

- Description updated

- Assignee set to ko1 (Koichi Sasada)

#2 - 01/31/2017 07:00 AM - ko1 (Koichi Sasada)

- Status changed from Open to Closed

Applied in changeset r57479.

allow Queue operation in trap.

thread_sync.c: allow spurious wakeup to check Queue status just after trap.

[Bug #12405]

test/thread/test_queue.rb: add a test for it.

#3 - 01/31/2017 07:01 AM - ko1 (Koichi Sasada)

We need to check Queue status change after trap handler.

Sorry for my late response and thank you for your reporting it.

#4 - 03/11/2017 06:45 PM - naruse (Yui NARUSE)

- Backport changed from 2.1: UNKNOWN, 2.2: UNKNOWN, 2.3: UNKNOWN to 2.1: UNKNOWN, 2.2: UNKNOWN, 2.3: UNKNOWN, 2.4: DONE

ruby_2_4 r57879 merged revision(s) 57477,57478,57479.

#5 - 03/13/2017 12:54 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.1: UNKNOWN, 2.2: UNKNOWN, 2.3: UNKNOWN, 2.4: DONE to 2.1: UNKNOWN, 2.2: REQUIRED, 2.3: REQUIRED, 2.4:

DONE

#6 - 03/20/2017 12:26 PM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.1: UNKNOWN, 2.2: REQUIRED, 2.3: REQUIRED, 2.4: DONE to 2.1: UNKNOWN, 2.2: REQUIRED, 2.3: DONE, 2.4: DONE

ruby_2_3 r58036 merged revision(s) 57477,57478,57479.

#7 - 03/25/2017 05:54 PM - usa (Usaku NAKAMURA)

- Backport changed from 2.1: UNKNOWN, 2.2: REQUIRED, 2.3: DONE, 2.4: DONE to 2.1: UNKNOWN, 2.2: REQUIRED, 2.3: REQUIRED, 2.4: DONE

nagachika-san, r57492 is also required.

#8 - 03/25/2017 06:07 PM - usa (Usaku NAKAMURA)

- Backport changed from 2.1: UNKNOWN, 2.2: REQUIRED, 2.3: REQUIRED, 2.4: DONE to 2.1: UNKNOWN, 2.2: DONE, 2.3: REQUIRED, 2.4: DONE

ruby_2_2 r58115 merged revision(s) 57477,57478,57479,57492.

#9 - 03/27/2017 03:49 PM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.1: UNKNOWN, 2.2: DONE, 2.3: REQUIRED, 2.4: DONE to 2.1: UNKNOWN, 2.2: DONE, 2.3: DONE, 2.4: DONE

ruby_2_3 r58164 merged revision(s) 57492.
